#!/usr/local/bin/python2.7

"""
See help.__doc__

version is set in conf.py

 Copyright (C) 2001-2006 Andrei Kulakov <ak@silmarill.org> GPL (see LICENSE)
"""

import os, sys
from cypack.data import data
from cypack import main
from cypack import conf
from cypack import log
import curses


try:
    import mad, ao
except ImportError:
    print 'Error: pymad and/or pyao modules are missing. In Debian their packages are called python-pyao and python-pymad.'
    sys.exit()
	
import warnings
try:
    warnings.filterwarnings('ignore','', FutureWarning, '', 0)
except NameError:
    pass


def init():
    """Create data dirs if they don't exist.
    
    conf.dir        - main program dir
    conf.playlists  - playlists dir in main dir
    """

    if not os.path.exists(conf.progdir):
        os.mkdir(conf.progdir)
    if not os.path.exists(conf.playlists):
        os.mkdir(conf.playlists)

if __name__ == "__main__":
    init()
    data.load()
    from cypack.scores import scores
    scores.load()
    curses.wrapper(main.main)
