"""ID3 tags (mp3 song info) manipulation."""

import time
import string
import ID3
from playlist import pl
from debug import debug

class Id3:
    def clear(self, files):
        """Clear each file's id3 title tag."""

        for fn in files:
            f = ID3.ID3(fn)
            f.title = ""
            f.write()


    def SetArtistTitle(self):
        """Set artist and title tag for each file."""

        import ui
        ui.doredraw = 0
        artist = ui.ask("Artist: ")
        title = ui.ask("Title: ")
        #f = ID3.ID3(pl.track.path)
        #f.delete()          # because it does not update artist and title otherwise..
        #del f
        f = ID3.ID3(pl.track.path)
        f['ARTIST'] = artist
        f['TITLE'] = title
        pl.albums[pl.albumindex][pl.index].id3(reload=1)
#        pl.track.id3(reload=1)
        ui.doredraw = 1


    def info(self):
        import ui
        ui.tracks_window = 0
        ui.do_clear = 1
        fname = pl.track.path
        try:
            f = ID3.ID3(fname)
        except:
            txt = '''
            Error reading ID3 tags.
            path:       %s
            name:       %s
            ''' % (fname, repr(pl.track.name))
        else:
            self.artist = self.album = self.title = ''
            if f.has_key("ARTIST"):
                self.artist = f["ARTIST"]
            if f.has_key("ALBUM"):
                self.album = f["ALBUM"]
            if f.has_key("TITLE"):
                self.title = f["TITLE"]
            valid_chars = string.printable[:95]
            for n in 'artist album title'.split():
                val = self.__dict__[n]
                nval = ''
                if val:
                    for c in val:
                        if c in valid_chars:
                            nval += c
                    self.__dict__[n] = nval

            txt = """
            artist:     %s
            album:      %s
            title:      %s
            path:       %s
            """ % (self.artist, self.album, self.title, fname)
        debug("ai, i: %s, %s"  % (pl.albumindex, pl.index))
        ui.fsdisplay(txt)


    def set_title(self, fn):
        """Set id3 title for this file."""

        f = ID3.ID3(fn)
        f.title = ui.ask("Title: ")
        f.write()


    def set_all(self, fn):
        """Set all id3 fields for the file."""

        fields = "title artist album comment year genre".split()
        f = ID3.ID3(fn)
        for field in fields:
            value = raw_input(field.capitalize() + ": ")
            exec "f.%s = '%s'" % (field, value)

id3 = Id3()
