from cycurses import cycurses
from data import data
import rand
import ui


def continuous():
    """Toggle continuous mode."""
    data.continuous = not data.continuous
    ui.fullredraw()


def play():
    """Cycle play modes.

    Tracks plays one track; dir - one dir; playlist - full playlist.
    """

    data.random = "off"
    m = data.play
    if   m == "playlist" : m = "track"
    elif m == "track"    : m = "dir"
    elif m == "dir"      : m = "playlist"
    data.play = m
    ui.fullredraw()


def random():
    """Cycle random modes.
    
    Track picks a random track from all playlist; dir picks a random
    dir; off plays tracks sequentially.
    """

    if data.play == 'track':
        data.play = "playlist"
    m = data.random
    if   m == "queue" : 
        m = "album"
        cycurses.win.clear()
    elif m == "album" : m = "off"
    elif m == "off"   : m = "track"
    elif m == "track" : 
        m = "queue"
        rand.reload_queue()
    data.random = m
    ui.fullredraw()


def no_repeat():
    """Toggle random no repeat mode."""
    if data.random == "off":
        data.random = "track"
    if not data.random_norepeat:
        rand.mk_randlist()
        data.random_norepeat = 1
    else:
        data.random_norepeat = 0
    ui.fullredraw()
