import threading
import time
import avkutil
import ui
from colors import colors


class StatThread(threading.Thread):
    """Show msg in progress bar for 3 seconds."""
    def __init__(self, msg, secs, time_set):
        threading.Thread.__init__(self)
        self.set = time_set
        mwidth = ui.w()-22
        msg = msg[:mwidth]
        stat.msg = msg.center(mwidth)
        self.secs = secs


    def run(self):
        time.sleep(self.secs)
        if self.set == stat.time_set:
            # we don't want to reset other instance's msg
            stat.msg = ''


class Stat:
    _shared = {}    # borg design
    def __init__(self):
        self.__dict__ = self._shared
        self.msg = ''


    def normal(self, msg, secs=3):
        """Show msg in progress bar for 3 secs."""
        self.msg = msg
        self.time_set = time.time()
        try:
            StatThread(msg, secs, self.time_set).start()
        except:
            pass


    def error(self, msg, secs=3):
        """Show error in progress bar."""
        self.msg = 'Error: ' + msg
        self.time_set = time.time()
        self.normal(self.msg, secs=secs)

stat = Stat()
