import threading
import os
import sys
import time
import urllib2

from data import data
import conf

base_url = "http://silmarill.org/cymbaline/"
vers_url = base_url + "version"
changes_url = base_url + "last_changes"


#if conf.use_proxy:
#    proxy_support = urllib2.ProxyHandler({"http" :
#                    "http://%(user)s:%(pass)s@%(host)s:%(port)d" %
#    proxy_info})
#    opener = urllib2.build_opener(proxy_support, urllib2.HTTPHandler)
#    urllib2.install_opener(opener)


class Check(threading.Thread):
    def get_update(self):
        print """
    New Cymbaline version is available

    If you don't want to check for new versions, set
    check_for_updates to 0 in data.py

    Hit Enter... """ 
        raw_input()
        changes = urllib2.urlopen(changes_url).read()
        print
        print changes
        print "Hit Enter..",
        raw_input("")
        print "\rDo you wish to download the latest version? [Y/n] ",
        sys.stdout.flush()
        ans = raw_input(" ")
        if not ans or ans in "Yy":
            if not legal_fname_pat.match(__version__):
                print "Illegal character(s) in __version__!!! Exiting.."
                sys.exit()
            cy_fname = "cymbaline-%s.tar.gz" % __version__
            cy_url = base_url + cy_fname
            try: 
                cy = urllib2.urlopen(cy_url).read()
                fname = os.path.expanduser("~/" + cy_fname)
                f = open(fname, 'w')
                f.write(cy)
                f.close()
                os.system("cd ~; tar zxvf %s" % fname)
                os.remove(fname)
                print """
        If all went right, Cymbaline should now be untarred to your home
        directory. If not, you can always get it at http://cy.silmarill.org
        To use new Cymbaline, login as root and run: python install.py.
        """
            except:
                print "Error fetching file."
        self.new_version = 0


    def run(self):
        """ If you started out the player and then we tried to check for update
        right away, and you quit in a second (for example if you made a typo),
        this thread may take 5-8 seconds (here) to finish. So, we first sleep
        for 30 seconds, then we set a timeout alarm for 4 seconds - hope that's
        long enough - and check for updates.
        """

        self.quit = 0
        self.new_version = None
        vers = None
        if conf.check_for_updates:
            if data.last_check_nv:
                passed = time.time() - data.last_check_nv
                if passed < 7*24*60*60: # 7 days
                    return
            for i in range(60):
                pass
                time.sleep(.5)
                if self.quit:
                    return
            try:
                vers = urllib2.urlopen(vers_url).read()[:-1]
            except:
                print '''
                Could not open the url to check for new versions of Cy.
                The likely cause is that you're not connected to the 'net.
                You may want to disable check_for_updates in conf.py file.
                You can try unix 'locate conf.py' command to find it.
                '''
            if vers and vers != conf.__version__:
                self.new_version = vers
            data.last_check_nv = time.time()
